/*
  Mod gwny projektu "Identyfikacja"

  Plik zawiera:
     funkcj startow Main.

  Kompilacja projektu:
     Jeeli korzystasz z IDE to nalezy utworzy nowy (pusty) projekt C++ Aplikacja konsolowa i zaczy pliki:
       - identification.h
       - identification.cpp
       - matrix.h
       - main.cpp
     Jeeli korzystasz z Linux'a to w terminalu mona wklepa:
        g++ -c main.cpp
        g++ -c identification.cpp
        g++ main.o identification.o
        ./a.out <- start programu
     Program powinien si kompilowa w wikrzoci rodowisk i systemw. Sprawdzaem na Linux\g++ oraz Windows\Visual Studio. 
  
  Dodatki:
     W folderze [dane] zajduj si przykadowe dane wejciowe. Mona z nich skorzysta poprzez lini komend

        ./a.out < dane/dane1.txt > out.txt

     Linia ta spowoduje uruchomienie programu (o ile jestemy w jego folderze i nazywa si on a.out).
     Jako dane wejciow wykorzysta plik dane/dane1.txt. Wyjcie zapisze do pliku out.txt w folderze programu.

  Copyrights (c) 2008 Micha Kowalik
  
  e-mail: maf-michal@gmail.com

  LICENCJA:
  Kod mona:
    - zastosowa w swoim programie pod warunkiem, e poinformuje si o tym autora i umieci o nim informacje,
    - poprawia/uleprza - chciabym by skontaktowano si ze mn w tej sprawie i napisno co i jak,
    - oddawa na zaliczenie o ile wyle si e-mail do autora z wielkimi podziekowaniami (odele adres na ktry bdziesz mg(a) wysac piwo).
*/

#include <iostream>

#include "identification.h"

using namespace std;

int main()
{
	Model model;
	try
	{
		model.LoadUY();
	}
	catch (int e)
	{
		switch (e)
		{
		case Model::ERR_1:
			cout << "Blad odczytu: Nie mozna odczytac pliku!";
			break;
		case Model::ERR_2:
			cout << "Blad odczytu: Niepoprawna wartosc ilosci pomiarow!";
			break;
		case Model::ERR_3:
			cout << "Blad odczytu: Niepoprawna wartosc ilosci wejsc!";
			break;
		case Model::ERR_4:
			cout << "Blad odczytu: Niepoprawna wartosc ilosci wyjsc!";
			break;
		case Model::ERR_5:
			cout << "Blad odczytu: Niepoprawna wartosc ilosci modeli!";
			break;
		case Model::ERR_6:
			cout << "Blad odczytu: Jedno z rownan wymaga zbyt wielu wejsc!";
			break;
		case RPN::ERR_BLADNAWIASU:
			cout << "Blad danych: Zle nawiasowanie jednego z rownan!";
			break;
		case RPN::ERR_NIEZNANYZNAK:
			cout << "Blad danych: W rownaniu znajduje sie nieznany znak!";
			break;
		}
		return e;
	}

	cout << endl << 'u' << endl << model.u() << endl;
	cout << 'y' << endl << model.y();

	try
	{
	    cout << endl << "Liczba modeli do zbadania: ";
	    unsigned x; cin >> x;

	    for (unsigned j=1; j<=x; j++)
	    {
	        cout << endl << " ===> Model #" << j << " ===>" << endl;
	        model.LoadModel();
	        cout << model.model() << endl;

	        Matrix<double> dop = model.Identify();
            cout << "Dopasowanie: " << endl << dop << endl;

            cout << "y':" << endl;
            for (unsigned i=0; i<model.u().Rows(); i++)
            {
                for (unsigned c=0; c<dop.Columns(); c++)
                {
                    double tmp = 0;
                    for (unsigned r=0; r<dop.Rows(); r++)
                        tmp += dop[r][c]*model.model()[r][c].Solve(model.u()[i]);
                    cout << tmp << " e=" << (model.y()[c][i]-tmp);
                    if (c+1 < dop.Columns()) cout << ' ';
                }
                cout << endl;
            }
	    }
	}
	catch (int e)
	{
		switch (e)
		{
		case MATRIX_ERR1:
			cout << "Blad operacji na macierzy: Allokacja pamieci!";
			break;
		case MATRIX_ERR2:
			cout << "Blad operacji na macierzy: Blad zasiegu!";
			break;
		case MATRIX_ERR3:
			cout << "Blad operacji na macierzy: Rozne rozmiary macierzy przy sumowaniu!";
			break;
		case MATRIX_ERR4:
			cout << "Blad operacji na macierzy: Rozmiar macierzy przy mnozeniu!";
			break;
		case MATRIX_ERR5:
			cout << "Blad operacji na macierzy: Macierz prostokatna przy operacji na macierzy kwadratowej!";
			break;
		case MATRIX_ERR6:
			cout << "Blad operacji na macierzy: Macierz jest nieodwracalna!";
			break;
		}
		return e;
	}

	getchar();
	return 0;
}
